﻿package {
	
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.text.TextField
	import flash.text.TextFormat;
	import flash.utils.getTimer

	public class ASTachoMeter extends Sprite {
		
		private var _interval:int=20
		private var _digit:int=1
		
		private var textField:TextField;
		private var textFormat:TextFormat
		private var generalFPS:uint
		private var currentFPS:uint
		private var preTime:int
		private var deltaTime:int
		private var count:int = 1		
		
		function ASTachoMeter():void {

			drawLayout()
			
			generalFPS = this.stage.frameRate
			preTime = getTimer()
			this.addEventListener(Event.ENTER_FRAME,onEnterFrame)
		}
		private function drawLayout():void {
			textField = new TextField()
			textField.y = 11.5
			textField.x = 40
			textField.width = 60
			textField.height = 18
			textField.autoSize = "right"
		
			addChild(textField)
		}
		private function onEnterFrame(event:Event):void {
				
			if (count++ >= interval) {
				outPut()
				count = 1	
			}
		}
		private function outPut():void {
			deltaTime = getTimer()-preTime
			preTime = getTimer()
			textField.text = String(1000 / (deltaTime / interval)).substr(0, _digit + 3);
			
		}
		[Inspectable(defaultValue=20)]
		public function get interval():int {
			return _interval
		}
		public function set interval(value:int):void {
			_interval = value
		}
		
		[Inspectable(defaultValue=1)]
		public function get digit():int {
			return _digit
		}
		public function set digit(value:int):void {
			_digit = value
		}

	}
}